﻿<h1 id="dynamic-arp-inspection">Dynamic ARP Inspection</h1>
<h3 id="--the-address-resolution-protocol-is-used-to-map-layer-3-to-layer-2-addresses-in-our-networks-endpoints-and-network-devices-will-have-a-arp-cachetable-for-those-mappings-in-our-networks-someone-malicious-could-spoof-arp-replies-and-perform-mitm-attacks-this-is-called-arp-spoofing-we-can-authenticate-arp-packets-by-implementing-dai-dynamic-arp-inspection">- The Address Resolution protocol is used to map Layer 3 to Layer 2 addresses in our networks. Endpoints and network devices will have a ARP Cache/Table for those mappings. In our networks someone malicious could spoof ARP replies and perform MITM attacks. this is called <strong>&quot;ARP Spoofing&quot;</strong>, we can authenticate ARP packets by implementing DAI (Dynamic ARP Inspection).</h3>
<h3 id="--dai-in-a-dhcp-environment-will-rely-on-the-dhcp-snooping-binding-database-table-to-authenticate-the-layer-3---layer-2-mappings-in-arp-requests-and-replies">- DAI in a DHCP environment will rely on the DHCP snooping binding database table to authenticate the Layer 3 - Layer 2 mappings in ARP requests and replies.</h3>
<p><img src="layer_2_security_network_diagram.png" alt="" /></p>
<h3 id="--for-this-how-to-we-will-first-need-to-get-our-network-ready-by-configuring-vlans-trunks-and-dhcp-snooping-if-you-do-not-know-how-to-configure-these-technologies-please-refer-to-our-other-how-tos-to-configure-dai-follow-the-configuration-below">- For this How to we will first need to get our network ready by configuring VLANs, Trunks and DHCP snooping. If you do not know how to configure these technologies please refer to our other How To's. To configure DAI follow the configuration below.</h3>
<p><code>SW3(config)#ip arp inspection vlan 10,20</code> # This command will enable ARP inspection for the specified VLANs. DAI will authenticate the Layer 2 and Layer 3 mappings for devices in your network to prevent spoofing.</p>
<p><img src="ip_arp_inspection_configuration.png" alt="" /></p>
<p><img src="ip_arp_inspection_configuration_01.png" alt="" /></p>
<h3 id="verification-now-that-we-have-enabled-dai-on-all-our-switches-lets-clear-the-arp-cache-in-our-dhcp-server-and-resend-the-dhcp-request-from-our-clients">Verification. Now that we have enabled DAI on all our switches lets clear the arp cache in our DHCP server and resend the DHCP request from our clients.</h3>
<p><code>R1#clear arp</code> # This command will clear the ARP table in our Cisco iOS router.</p>
<p><img src="clear_arp.png" alt="" /></p>
<p><img src="DAI_log_message.png" alt="" /></p>
<h3 id="here-we-can-see-an-error-message-for-our-dhcp-server-this-is-because-the-dhcp-server-is-a-static-address-and-is-not-in-our-dhcp-snooping-binding-table-we-can-fix-this-issue-with-an-arp-acl-or-by-configuring-the-arp-trust-command-on-interfaces-facing-the-dhcp-server">Here we can see an error message for our DHCP server. This is because the DHCP server is a static address and is not in our DHCP snooping binding table. We can fix this issue with an <strong>&quot;ARP ACL&quot;</strong> or by configuring the <strong>&quot;ARP Trust&quot;</strong> command on interfaces facing the DHCP server.</h3>
<p><code>SW3(config)#interface eth0/0</code> # Brings you into the interface subconfiguration mode</p>
<p><code>SW3(config-if)#ip arp inspection trust</code> # This command allows ARP packets to be authenticated without the L2-L3 mappings being in the DHCP snooping table</p>
<p><code>SW2(config)#arp access-list DAI</code> # This command creates an ACL specifically for ARP packets</p>
<p><code>SW2(config-arp-acl)#permit ip host 10.10.10.254 host aabb.cc00.8000</code> # This command permits a specific host on the ARP ACL</p>
<p><code>SW2(config-arp-acl)#permit ip host 10.10.20.254 host aabb.cc00.8000</code> # This command permits a specific host on the ARP ACL</p>
<p><code>SW2(config)#ip arp inspection filter DAI vlan 10,20</code> # This command will apply the the ARP ACL for the specified VLANs.</p>
<h3 id="full-configuration-below">Full configuration below</h3>
<p><img src="ip_arp_inspection_trust_cmd.png" alt="" /></p>
<p><img src="arp_acl.png" alt="" /></p>
<h3 id="show-commands">Show commands</h3>
<p><img src="show_ip_arp_inspection.png" alt="" /></p>
